import numpy as np
import matplotlib.pyplot as plt
from scipy.optimize import fsolve

def f(x): # Définition du système d’Équations (3.8)
    f1 = np.arccos(-1/x[0]) - np.arctan(x[1]) + x[0]*np.sin(np.arccos(-1/x[0]))
    + np.arccos((U_c-x[2])/x[3])
    - x[0]*np.sin(-np.arccos((U_c-x[2])/x[3])+np.arctan(x[1])) - 2*np.pi
    
    f2 = -np.arccos(-1/x[0]) - np.arctan(x[1]) 
    + x[0]*np.sin(-np.arccos(-1/x[0])) + np.arccos((U_d-x[2])/x[3])
    - x[0]*np.sin(-np.arccos((U_d-x[2])/x[3])+np.arctan(x[1])) + 2*np.pi
    
    f3 = x[2]- U_max + x[3]*np.cos(+np.arccos(-1/x[0])-np.arctan(x[1]))
    
    f4 = x[2]- U_min + x[3]*np.cos(-np.arccos(-1/x[0])-np.arctan(x[1]))
    return [f1,f2,f3,f4]

f_aq = 200000 # Fréquence d’acquisition (Hz)
N = 400000 # Nombre de points d’acquisition 


U = np.genfromtxt("") # Import du signal de l'OFI [V] 

# Aperçu du signal :

plt.plot(power_vibro)
plt.xlim(0,6000)
plt.show()

# Définition de droites horizontales qui vont séparer le signal en 4 zones :
# Ces variables sont à compléter en fonction du signal enregistré 
#et de l'aperçu affiché ci-dessus

milieu =  # Ordonnée d'une droite qui sépare les U_plus et U_plus"chapeau" des U_moins
#et U_moins"chapeau"
min_max =  # Ordonnée d'une droite qui sépare les U_plus des U_plus"chapeau"
max_min = # Ordonnée d'une droite qui sépare les U_moins des U_moins"chapeau"


# Lissage de la fonction :
    
taille_fenetre = 10 # Nombre de points dans la fenêtre glissante
U_lisse = [] # Signal de l'OFI lissé (V)
for i in range(0,U.size) :
    if i < taille_fenetre/2 or i > U.size - taille_fenetre/2 : 
    # Les premiers et derniers points ne sont pas lissés
        U_lisse.append(U[i])
    else : 
        moyenne = 0
        for j in range(int(-taille_fenetre/2),int(taille_fenetre/2)) : 
        # Lissage sur la taille de la fenetre
            moyenne += power_vibro[i+j]
        moyenne = moyenne / taille_fenetre
        U_lisse.append(moyenne)
        
U_lisse = np.array(U_lisse)
            

# Calcul la différence entre le signal et le signal lissé : 

diff = U_lisse - U



# Aperçu de cette différence, chaque pic correspond à une discontinuité :

plt.plot(diff)
plt.xlim(0,6000)
plt.show()

seuil = 
# Seuil à régler de sorte à ce que celui-ci soit inférieur au valeurs 
#des pics (en valeur absolue) et supérieur au bruit de fond (ordre de grandeur : 0.005)
# Si à la fin du programme, des discontinuités sont détectés à des endroits absurdes, 
#baisser ce seuil.

# Élimination du bruit en attribuant la valeur 0 lorsque diff est inférieur au seuil :
    
for i in range(0,diff.size) :
    if abs(diff[i]) < seuil : 
        diff[i] = 0

# Recherches des discontinuités dans le signal :

x_discontinuite = [] # Initialisation des abscisses des discontinuités

# Recherche des points de diff où il y a un changement de signe 
#(signe de discontinuité) :
for i in range(0,diff.size-2) :
    if diff[i]*diff[i+2] < 0 and i not in x_discontinuite : 
    # On regarde entre 2 points car en général le point entre les 2 signes passent par zero 
    #à cause du seuillage
        x_discontinuite.append(i+1) 
        # On prend le points entre les 2 de signes différents

# Les abscisses des discontinuités étant détectés, on identifie maintenant l'abscisse 
#des points situés juste avant et après chaque discontinuité.
x_avant = [] # abscisses des points situés avant les discontinuités
x_apres = [] # abscisses des points situés après les discontinuités


# on cherche ces points en regardant dans une petite fenetre autour des discontinuités :
    
for i in range(0,len(x_discontinuite)) :
    fenetre = abs(U[x_discontinuite[i]-2:x_discontinuite[i]+3]-milieu) 
    x_avant.append(np.where(fenetre==max(fenetre))[0][0]+x_discontinuite[i]-2) 
    # Ce sont les maximums de chaque fenêtre
    x_apres.append(np.where(fenetre==min(fenetre))[0][0]+x_discontinuite[i]-2) 
    # Ce sont les minimums de chaque fenêtre


x_avant = np.array(x_avant)
x_apres = np.array(x_apres)


# Les étapes qui suivent servent à identifier quels points correspondent aux abscisses 
#de U_plus, U_moins, U"chapeau"+ et U"chapeau"-.

x_U_plus = [] # Abscisses des points correspondant aux U_plus 
x_U_moins = [] # Abscisses des points correspondant aux U_moins

# Ces points sont différenciés grâce aux ordonnées des droites horizontales définies 
#au début du programme : 
    
for x in x_avant :
    if U[x] > min_max :
        x_U_plus.append(x-5)
    elif U[x] < max_min :
        x_U_moins.append(x)
     
x_U_plus = np.array(x_U_plus)
x_U_moins = np.array(x_U_moins)


x_U_c_plus = [] # Abscisses des points correspondant aux U"chapeau"+ 
x_U_c_moins = [] # Abscisses des points correspondant aux U"chapeau"-
 
    
for x in x_apres :
    if min_max > U[x] > milieu :
        x_U_c_plus.append(x)
    elif max_min < U[x] < milieu :
        x_U_c_moins.append(x)

            
x_U_c_plus = np.array(x_U_c_plus)
x_U_c_moins = np.array(x_U_c_moins)


# Initialisation des listes des valeurs de U_plus, U_moins, U"chapeau"+ et U"chapeau"- : 

liste_U_c_plus = []
liste_U_c_moins = []
liste_U_plus = []
liste_U_moins = []
    
# Récupération des valeurs :
    
for x in x_U_plus :
    liste_U_c_plus.append(U[x])
for x in x_U_moins :
    liste_U_c_moins.append(U[x])
        
liste_U_c_plus = np.array(liste_U_c_plus)
liste_U_c_moins = np.array(liste_U_c_moins)


for x in x_U_c_plus :
    liste_U_c_plus.append(U[x])
for x in x_U_c_moins :
    liste_U_c_moins.append(U[x])

# Estimation des valeurs comme la moyenne des listes

U_plus = np.mean(liste_U_plus)
U_moins = np.mean(liste_U_moins)
U_c_plus = np.mean(liste_U_c_plus)
U_c_moins = np.mean(liste_U_c_moins)


# Vérification graphique du bon fonctionnement de l'algorithme :


font_size = 18
plt.figure(figsize = (10,6))
plt.tick_params(axis = 'both', labelsize = font_size)
plt.grid(visible = True, axis = 'x', which = 'major', linestyle= '--')

plt.plot(U)
plt.plot(x_U_c_plus,U[x_U_c_plus],"xr",markersize = 10)
plt.hlines(U_c_plus,0,2e4, color = 'red', linestyle = '--')
plt.plot(x_U_c_moins,U[x_U_c_moins],"xg",markersize = 10)
plt.hlines(U_c_moins,0,2e4, color = 'green', linestyle = '--')
plt.plot(x_U_plus,U[x_U_plus],"xk",markersize = 10)
plt.hlines(U_plus,0,2e4, color = 'black', linestyle = '--')
plt.plot(x_U_moins,U[x_U_moins],"xm",markersize = 10)
plt.hlines(U_moins,0,2e4, color = 'purple', linestyle = '--')
plt.yticks([U_c,U_d,U_max,U_min],
[round(U_c,3),round(U_d,3),round(U_max,3),round(U_min,3)])
plt.xlabel("$t$ [ms]",fontsize = font_size)
plt.ylabel("$U$ [V]",fontsize = font_size)
plt.xlim(5000,13000)
plt.show()
    

# Résolution du système d'équation (3.8)
C,alpha,U0,upsilon = 
fsolve(f,(10,5,(U_plus + U_moins)/2,(U_plus - U_moins )/2), xtol=1e-12)



# Affichage des résultats :
print("upslion = "+str(upsilon))
print("U0 = "+str(U0))
print("C = "+str(C))
print("alpha = "+str(alpha))